//
// Utilisation de new et delete : prog19.cc
//				  cas des tableaux de dimension 2
//

#include <stdio.h>
#include <stdlib.h>

const int NB_COL = 3;

void lecture(int (*) [NB_COL], int);
void affiche(int (*) [NB_COL], int);


int main()
{
 int ligne, resultat;

 printf("Combien de lignes : ");
 while((resultat = scanf("%d", &ligne)) != EOF)
 {
  if (resultat != 1 || ligne < 0)
    fprintf(stderr, "Erreur : valeur incorrecte\n");
    else
    {
     int (*ptr)[NB_COL] = new int[ligne][NB_COL];
     lecture(ptr, ligne);
     affiche(ptr, ligne);
     delete [] ptr;
    }
  printf("Combien de lignes : ");
 }
 return 0;
}

// Lecture du tableau
void lecture(int (*ptr)[NB_COL], int ligne)
{
 int i, j;
 for(i = 0; i < ligne; i++)
   for(j = 0; j < NB_COL; j++)
   {
    printf("tab[%d][%d] = ", i, j);
    scanf("%d",&ptr[i][j]);
   }
}

// Affichage du tableau
void affiche(int (*ptr)[NB_COL], int ligne)
{
 int i, j;
 printf("===============\n");
 for(i = 0; i < ligne; i++)
 {
   for(j = 0; j < NB_COL; j++)
    printf("tab[%d][%d] = %d\n", i, j,ptr[i][j]);
 }
 fflush(stdin);
}

