//
// Programme 14 : 
//		 	Paramètres par défaut
//			Pointeur sur une fonction
//

#include <stdio.h>

int croissant(int x, int y)
{
 return x > y;
}  

int decroissant(int x, int y)
{
 return x < y;
} 

void echange(int &x, int &y)
{
 int tmp = x;
 x = y;
 y = tmp;
} 

int tri(int *tab, int taille, int (*compare) (int, int) = croissant)
{ 
 int i, j, place;
 for(i = 0; i < taille - 1; i++)
   {
    place = i; 
    for(j = i+1; j < taille; j++)
      if((* compare)(tab[place],tab[j]))
        place = j;
    echange(tab[i], tab[place]);
   }      
}

void affiche(int *t, int n)
{
 int i;
 for(i = 0; i < n; i++)
   printf("%4d",t[i]);
 putchar('\n');
}
   
int main()
{
 int tableau1[] =  {7, 12, 4, 13, 19, 6, 6, 9, 1, 65, 0};
 const int nb = sizeof(tableau1) / sizeof(int);
 affiche(tableau1, nb);
 tri(tableau1, nb);
 affiche(tableau1, nb);
 tri(tableau1, nb,decroissant);
 affiche(tableau1, nb);
 return 0;
} 
