#include <qobject.h>
#include <iostream> 

class Receveur : public QObject
{
  Q_OBJECT // Macro pour utiliser le modèle Qt
 public:
   Receveur(QObject *parent=0, char *name=0) : QObject(parent, name)
   {
   }
 public slots:
   void get(const char *x )
   {
     std::cout << "Receveur: " << x << std::endl;
   }
};

class EnvoyeurA : public QObject
{
  Q_OBJECT
 public:
   EnvoyeurA( QObject *parent=0, char *name=0 ) : QObject( parent, name )
   {
   }
   void doSend()
   {
     emit(send("Signal de A"));
   }
signals:
   void send(const char *);
};

class EnvoyeurB : public QObject
{
  Q_OBJECT
 public:
   EnvoyeurB( QObject *parent=0, char *name=0 ) : QObject( parent, name )
   {
   }
   void doStuff()
   {
     emit(transmit("Signal de B"));
   }
 signals:
   void transmit(const char *);
};

