//
// Utilisation de new et delete : prog18.cc
//

#include <stdio.h>
#include <string.h>


int get(char**&);
void put(char **, int);
void del(char **, int);

int main()
{
 char **pointeur = NULL;
 int compteur = get(pointeur);
 put(pointeur, compteur);
 del(pointeur, compteur);
 return 0;
}

int get(char **&ptr)
{
 const int DIM = 256;
 int index = 0;
 char buffer[DIM];
 printf("Entrez une chaine : ");
 while(strlen(fgets(buffer, DIM, stdin)) > 1 )
 {
  char *string = new char[strlen(buffer) + 1];
  strcpy(string, buffer);
  char ** temp = new char*[index + 1];
  for(int i = 0; i < index; i++) temp[i] = ptr[i];
  temp[index++] = string;
  delete [] ptr;
  ptr = temp;
  printf("Nouvelle chaine : ");
 }
 return index;
}

void put(char **ptr, int compteur)
{
 printf("\nLes chaines :\n");
 for(int i = 0; i < compteur; i++) printf("%s", ptr[i]);
}

void del(char **ptr, int compteur)
{
 for(int i = 0; i < compteur; i++) delete [] ptr[i];
 delete [] ptr;
}     


